Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 502)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 503)
@@ -730,231 +1675,11 @@
 	    call_destroy_media(call->index);
 
-	/* Remove timers. */
-	schedule_call_timer(call, &call->refresh_tm, REFRESH_CALL_TIMER, 0);
-	schedule_call_timer(call, &call->hangup_tm, HANGUP_CALL_TIMER, 0);
-
 	/* Free call */
 	call->inv = NULL;
-	--pjsua.call_cnt;
-    }
-}
-
-
-/*
- * Callback called by event framework when the xfer subscription state
- * has changed.
- */
-static void xfer_on_evsub_state( pjsip_evsub *sub, pjsip_event *event)
-{
-    
-    PJ_UNUSED_ARG(event);
-
-    /*
-     * We're only interested when subscription is terminated, to 
-     * clear the xfer_sub member of the inv_data.
-     */
-    if (pjsip_evsub_get_state(sub) == PJSIP_EVSUB_STATE_TERMINATED) {
-	pjsua_call *call;
-
-	call = pjsip_evsub_get_mod_data(sub, pjsua.mod.id);
-	if (!call)
-	    return;
-
-	pjsip_evsub_set_mod_data(sub, pjsua.mod.id, NULL);
-	call->xfer_sub = NULL;
-
-	PJ_LOG(3,(THIS_FILE, "Xfer subscription terminated"));
-    }
-}
-
-
-/*
- * Follow transfer (REFER) request.
- */
-static void on_call_transfered( pjsip_inv_session *inv,
-			        pjsip_rx_data *rdata )
-{
-    pj_status_t status;
-    pjsip_tx_data *tdata;
-    pjsua_call *existing_call;
-    int new_call;
-    const pj_str_t str_refer_to = { "Refer-To", 8};
-    pjsip_generic_string_hdr *refer_to;
-    char *uri;
-    pj_str_t tmp;
-    struct pjsip_evsub_user xfer_cb;
-    pjsip_status_code code;
-    pjsip_evsub *sub;
-
-    existing_call = inv->dlg->mod_data[pjsua.mod.id];
-
-    /* Find the Refer-To header */
-    refer_to = (pjsip_generic_string_hdr*)
-	pjsip_msg_find_hdr_by_name(rdata->msg_info.msg, &str_refer_to, NULL);
-
-    if (refer_to == NULL) {
-	/* Invalid Request.
-	 * No Refer-To header!
-	 */
-	PJ_LOG(4,(THIS_FILE, "Received REFER without Refer-To header!"));
-	pjsip_dlg_respond( inv->dlg, rdata, 400, NULL, NULL, NULL);
-	return;
-    }
-
-    /* Notify callback */
-    code = PJSIP_SC_OK;
-    if (pjsua.cb.on_call_transfered)
-	(*pjsua.cb.on_call_transfered)(existing_call->index,
-				       &refer_to->hvalue, &code);
-
-    if (code < 200)
-	code = 200;
-    if (code >= 300) {
-	/* Application rejects call transfer request */
-	pjsip_dlg_respond( inv->dlg, rdata, code, NULL, NULL, NULL);
-	return;
-    }
-
-    PJ_LOG(3,(THIS_FILE, "Call to %.*s is being transfered to %.*s",
-	      (int)inv->dlg->remote.info_str.slen,
-	      inv->dlg->remote.info_str.ptr,
-	      (int)refer_to->hvalue.slen, 
-	      refer_to->hvalue.ptr));
-
-    /* Init callback */
-    pj_memset(&xfer_cb, 0, sizeof(xfer_cb));
-    xfer_cb.on_evsub_state = &xfer_on_evsub_state;
-
-    /* Create transferee event subscription */
-    status = pjsip_xfer_create_uas( inv->dlg, &xfer_cb, rdata, &sub);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create xfer uas", status);
-	pjsip_dlg_respond( inv->dlg, rdata, 500, NULL, NULL, NULL);
-	return;
-    }
-
-    /* Accept the REFER request, send 200 (OK). */
-    pjsip_xfer_accept(sub, rdata, code, NULL);
-
-    /* Create initial NOTIFY request */
-    status = pjsip_xfer_notify( sub, PJSIP_EVSUB_STATE_ACTIVE,
-				100, NULL, &tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create NOTIFY to REFER", status);
-	return;
-    }
-
-    /* Send initial NOTIFY request */
-    status = pjsip_xfer_send_request( sub, tdata);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to send NOTIFY to REFER", status);
-	return;
-    }
-
-    /* We're cheating here.
-     * We need to get a null terminated string from a pj_str_t.
-     * So grab the pointer from the hvalue and NULL terminate it, knowing
-     * that the NULL position will be occupied by a newline. 
-     */
-    uri = refer_to->hvalue.ptr;
-    uri[refer_to->hvalue.slen] = '\0';
-
-    /* Now make the outgoing call. */
-    tmp = pj_str(uri);
-    status = pjsua_call_make_call(existing_call->acc_index, &tmp, &new_call);
-    if (status != PJ_SUCCESS) {
-
-	/* Notify xferer about the error */
-	status = pjsip_xfer_notify(sub, PJSIP_EVSUB_STATE_TERMINATED,
-				   500, NULL, &tdata);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Unable to create NOTIFY to REFER", 
-			  status);
-	    return;
-	}
-	status = pjsip_xfer_send_request(sub, tdata);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Unable to send NOTIFY to REFER", 
-			  status);
-	    return;
-	}
-	return;
-    }
-
-    /* Put the server subscription in inv_data.
-     * Subsequent state changed in pjsua_inv_on_state_changed() will be
-     * reported back to the server subscription.
-     */
-    pjsua.calls[new_call].xfer_sub = sub;
-
-    /* Put the invite_data in the subscription. */
-    pjsip_evsub_set_mod_data(sub, pjsua.mod.id, &pjsua.calls[new_call]);
-}
-
-
-/*
- * This callback is called when transaction state has changed in INVITE
- * session. We use this to trap:
- *  - incoming REFER request.
- *  - incoming MESSAGE request.
- */
-static void pjsua_call_on_tsx_state_changed(pjsip_inv_session *inv,
-					    pjsip_transaction *tsx,
-					    pjsip_event *e)
-{
-    pjsua_call *call = inv->dlg->mod_data[pjsua.mod.id];
-
-    if (tsx->role==PJSIP_ROLE_UAS &&
-	tsx->state==PJSIP_TSX_STATE_TRYING &&
-	pjsip_method_cmp(&tsx->method, &pjsip_refer_method)==0)
-    {
-	/*
-	 * Incoming REFER request.
-	 */
-	on_call_transfered(call->inv, e->body.tsx_state.src.rdata);
-
-    }
-    else if (tsx->role==PJSIP_ROLE_UAS &&
-	     tsx->state==PJSIP_TSX_STATE_TRYING &&
-	     pjsip_method_cmp(&tsx->method, &pjsip_message_method)==0)
-    {
-	/*
-	 * Incoming MESSAGE request!
-	 */
-	pjsip_rx_data *rdata;
-	pjsip_msg *msg;
-	pjsip_accept_hdr *accept_hdr;
-	pj_status_t status;
-
-	rdata = e->body.tsx_state.src.rdata;
-	msg = rdata->msg_info.msg;
-
-	/* Request MUST have message body, with Content-Type equal to
-	 * "text/plain".
-	 */
-	if (pjsua_im_accept_pager(rdata, &accept_hdr) == PJ_FALSE) {
-
-	    pjsip_hdr hdr_list;
-
-	    pj_list_init(&hdr_list);
-	    pj_list_push_back(&hdr_list, accept_hdr);
-
-	    pjsip_dlg_respond( inv->dlg, rdata, PJSIP_SC_NOT_ACCEPTABLE_HERE, 
-			       NULL, &hdr_list, NULL );
-	    return;
-	}
-
-	/* Respond with 200 first, so that remote doesn't retransmit in case
-	 * the UI takes too long to process the message. 
-	 */
-	status = pjsip_dlg_respond( inv->dlg, rdata, 200, NULL, NULL, NULL);
-
-	/* Process MESSAGE request */
-	pjsua_im_process_pager(call->index, &inv->dlg->remote.info_str,
-			       &inv->dlg->local.info_str, rdata);
-    }
-
-}
-
+	--pjsua_var.call_cnt;
+    }
+
+    PJSUA_UNLOCK();
+}
 
 /*
@@ -971,122 +1696,4 @@
 }
 
-
-/*
- * Create inactive SDP for call hold.
- */
-static pj_status_t create_inactive_sdp(pjsua_call *call,
-				       pjmedia_sdp_session **p_answer)
-{
-    pj_status_t status;
-    pjmedia_sdp_conn *conn;
-    pjmedia_sdp_attr *attr;
-    pjmedia_sdp_session *sdp;
-
-    /* Create new offer */
-    status = pjmedia_endpt_create_sdp(pjsua.med_endpt, pjsua.pool, 1,
-				      &call->skinfo, &sdp);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create local SDP", status);
-	return status;
-    }
-
-    /* Get SDP media connection line */
-    conn = sdp->media[0]->conn;
-    if (!conn)
-	conn = sdp->conn;
-
-    /* Modify address */
-    conn->addr = pj_str("0.0.0.0");
-
-    /* Remove existing directions attributes */
-    pjmedia_sdp_media_remove_all_attr(sdp->media[0], "sendrecv");
-    pjmedia_sdp_media_remove_all_attr(sdp->media[0], "sendonly");
-    pjmedia_sdp_media_remove_all_attr(sdp->media[0], "recvonly");
-    pjmedia_sdp_media_remove_all_attr(sdp->media[0], "inactive");
-
-    /* Add inactive attribute */
-    attr = pjmedia_sdp_attr_create(pjsua.pool, "inactive", NULL);
-    pjmedia_sdp_media_add_attr(sdp->media[0], attr);
-
-    *p_answer = sdp;
-
-    return status;
-}
-
-/*
- * Called when session received new offer.
- */
-static void pjsua_call_on_rx_offer(pjsip_inv_session *inv,
-				   const pjmedia_sdp_session *offer)
-{
-    pjsua_call *call;
-    pjmedia_sdp_conn *conn;
-    pjmedia_sdp_session *answer;
-    pj_bool_t is_remote_active;
-    pj_status_t status;
-
-    call = inv->dlg->mod_data[pjsua.mod.id];
-
-    /*
-     * See if remote is offering active media (i.e. not on-hold)
-     */
-    is_remote_active = PJ_TRUE;
-
-    conn = offer->media[0]->conn;
-    if (!conn)
-	conn = offer->conn;
-
-    if (pj_strcmp2(&conn->addr, "0.0.0.0")==0 ||
-	pj_strcmp2(&conn->addr, "0")==0)
-    {
-	is_remote_active = PJ_FALSE;
-
-    } 
-    else if (pjmedia_sdp_media_find_attr2(offer->media[0], "inactive", NULL))
-    {
-	is_remote_active = PJ_FALSE;
-    }
-
-    PJ_LOG(4,(THIS_FILE, "Received SDP offer, remote media is %s",
-	      (is_remote_active ? "active" : "inactive")));
-
-    /* Supply candidate answer */
-    if (is_remote_active) {
-	status = pjmedia_endpt_create_sdp( pjsua.med_endpt, call->inv->pool, 1,
-					   &call->skinfo, &answer);
-    } else {
-	status = create_inactive_sdp( call, &answer );
-    }
-
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create local SDP", status);
-	return;
-    }
-
-    status = pjsip_inv_set_sdp_answer(call->inv, answer);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to set answer", status);
-	return;
-    }
-
-}
-
-#if 0
-/* Disconnect call */
-static void call_disconnect(pjsip_inv_session *inv,
-			    int st_code)
-{
-    pjsip_tx_data *tdata;
-    pj_status_t status;
-
-    status = pjsip_inv_end_session(inv, st_code, NULL, &tdata);
-    if (status == PJ_SUCCESS)
-	status = pjsip_inv_send_msg(inv, tdata);
-
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to disconnect call", status);
-    }
-}
-#endif
 
 /*
@@ -1098,4 +1705,5 @@
 				       pj_status_t status)
 {
+    int prev_media_st = 0;
     pjsua_call *call;
     pjmedia_session_info sess_info;
@@ -1106,5 +1714,7 @@
     char tmp[PJSIP_MAX_URL_SIZE];
 
-    call = inv->dlg->mod_data[pjsua.mod.id];
+    PJSUA_LOCK();
+
+    call = inv->dlg->mod_data[pjsua_var.mod.id];
 
     if (status != PJ_SUCCESS) {
@@ -1120,12 +1730,15 @@
 	    //call_disconnect(inv, PJSIP_SC_UNSUPPORTED_MEDIA_TYPE);
 	}
+
+	PJSUA_UNLOCK();
 	return;
-
     }
 
     /* Destroy existing media session, if any. */
 
-    if (call)
+    if (call) {
+	prev_media_st = call->media_st;
 	call_destroy_media(call->index);
+    }
 
     /* Get local and remote SDP */
@@ -1137,4 +1750,5 @@
 		     status);
 	//call_disconnect(inv, PJSIP_SC_UNSUPPORTED_MEDIA_TYPE);
+	PJSUA_UNLOCK();
 	return;
     }
@@ -1147,9 +1761,7 @@
 		     status);
 	//call_disconnect(inv, PJSIP_SC_UNSUPPORTED_MEDIA_TYPE);
+	PJSUA_UNLOCK();
 	return;
     }
-
-    if (pjsua.config.null_audio)
-	return;
 
     /* Create media session info based on SDP parameters. 
@@ -1157,5 +1769,5 @@
      */    
     status = pjmedia_session_info_from_sdp( call->inv->dlg->pool, 
-					    pjsua.med_endpt, 
+					    pjsua_var.med_endpt, 
 					    1,&sess_info, 
 					    local_sdp, remote_sdp);
@@ -1164,115 +1776,88 @@
 		     status);
 	//call_disconnect(inv, PJSIP_SC_UNSUPPORTED_MEDIA_TYPE);
+	PJSUA_UNLOCK();
 	return;
     }
 
-    /* Override ptime, if this option is specified. */
-    if (pjsua.config.ptime) {
-	sess_info.stream_info[0].param->setting.frm_per_pkt = (pj_uint8_t)
-	    (pjsua.config.ptime / 
-	      sess_info.stream_info[0].param->info.frm_ptime);
-	if (sess_info.stream_info[0].param->setting.frm_per_pkt==0)
-	    sess_info.stream_info[0].param->setting.frm_per_pkt = 1;
-    }
-
-    /* Optionally, application may modify other stream settings here
-     * (such as jitter buffer parameters, codec ptime, etc.)
-     */
-
-    /* Create session based on session info. */
-    status = pjmedia_session_create( pjsua.med_endpt, &sess_info,
-				     &call->med_tp,
-				     call, &call->session );
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create media session", 
-		     status);
-	//call_disconnect(inv, PJSIP_SC_UNSUPPORTED_MEDIA_TYPE);
-	return;
-    }
-
-
-    /* Get the port interface of the first stream in the session.
-     * We need the port interface to add to the conference bridge.
-     */
-    pjmedia_session_get_port(call->session, 0, &media_port);
-
-
-    /*
-     * Add the call to conference bridge.
-     */
-    port_name.ptr = tmp;
-    port_name.slen = pjsip_uri_print(PJSIP_URI_IN_REQ_URI,
-				     call->inv->dlg->remote.info->uri,
-				     tmp, sizeof(tmp));
-    if (port_name.slen < 1) {
-	port_name = pj_str("call");
-    }
-    status = pjmedia_conf_add_port( pjsua.mconf, call->inv->pool,
-				    media_port, 
-				    &port_name,
-				    &call->conf_slot);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create conference slot", 
-		     status);
-	call_destroy_media(call->index);
-	//call_disconnect(inv, PJSIP_SC_INTERNAL_SERVER_ERROR);
-	return;
-    }
-
-    /* If auto-play is configured, connect the call to the file player 
-     * port 
-     */
-    if (pjsua.config.auto_play && pjsua.config.wav_file.slen && 
-	call->inv->role == PJSIP_ROLE_UAS) 
+    /* Check if media is put on-hold */
+    if (sess_info.stream_cnt == 0 || 
+	sess_info.stream_info[0].dir == PJMEDIA_DIR_NONE)
     {
 
-	pjmedia_conf_connect_port( pjsua.mconf, pjsua.player[0].slot, 
-				   call->conf_slot, 0);
-
-    }
-    if (pjsua.config.auto_loop && call->inv->role == PJSIP_ROLE_UAS) {
-
-	pjmedia_conf_connect_port( pjsua.mconf, call->conf_slot, 
-				   call->conf_slot, 0);
-
-    }
-    if (pjsua.config.auto_conf) {
-	unsigned i;
-
-	pjmedia_conf_connect_port( pjsua.mconf, 0, call->conf_slot, 0);
-	pjmedia_conf_connect_port( pjsua.mconf, call->conf_slot, 0, 0);
-
-	for (i=0; i < pjsua.config.max_calls; ++i) {
-
-	    if (!pjsua.calls[i].session)
-		continue;
-
-	    pjmedia_conf_connect_port( pjsua.mconf, call->conf_slot, 
-				       pjsua.calls[i].conf_slot, 0);
-	    pjmedia_conf_connect_port( pjsua.mconf, pjsua.calls[i].conf_slot,
-				       call->conf_slot, 0);
+	/* Determine who puts the call on-hold */
+	if (prev_media_st == PJSUA_CALL_MEDIA_ACTIVE) {
+	    if (pjmedia_sdp_neg_was_answer_remote(call->inv->neg)) {
+		/* It was local who offer hold */
+		call->media_st = PJSUA_CALL_MEDIA_LOCAL_HOLD;
+	    } else {
+		call->media_st = PJSUA_CALL_MEDIA_REMOTE_HOLD;
+	    }
 	}
 
-    } 
-    
-    /* Normal operation: if no auto_xx is given, connect new call to 
-     * the sound device port (port zero) in the main conference bridge.
-     */
-    if (pjsua.config.auto_play == 0 && pjsua.config.auto_loop == 0 &&
-	pjsua.config.auto_conf == 0)
+	call->media_dir = PJMEDIA_DIR_NONE;
+
+    } else {
+
+	/* Override ptime, if this option is specified. */
+	PJ_TODO(set_codec_ptime_in_call);
+
+
+	/* Optionally, application may modify other stream settings here
+	 * (such as jitter buffer parameters, codec ptime, etc.)
+	 */
+
+	/* Create session based on session info. */
+	status = pjmedia_session_create( pjsua_var.med_endpt, &sess_info,
+					 &call->med_tp,
+					 call, &call->session );
+	if (status != PJ_SUCCESS) {
+	    pjsua_perror(THIS_FILE, "Unable to create media session", 
+			 status);
+	    //call_disconnect(inv, PJSIP_SC_UNSUPPORTED_MEDIA_TYPE);
+	    PJSUA_UNLOCK();
+	    return;
+	}
+
+
+	/* Get the port interface of the first stream in the session.
+	 * We need the port interface to add to the conference bridge.
+	 */
+	pjmedia_session_get_port(call->session, 0, &media_port);
+
+
+	/*
+	 * Add the call to conference bridge.
+	 */
+	port_name.ptr = tmp;
+	port_name.slen = pjsip_uri_print(PJSIP_URI_IN_REQ_URI,
+					 call->inv->dlg->remote.info->uri,
+					 tmp, sizeof(tmp));
+	if (port_name.slen < 1) {
+	    port_name = pj_str("call");
+	}
+	status = pjmedia_conf_add_port( pjsua_var.mconf, call->inv->pool,
+					media_port, 
+					&port_name,
+					(unsigned*)&call->conf_slot);
+	if (status != PJ_SUCCESS) {
+	    pjsua_perror(THIS_FILE, "Unable to create conference slot", 
+			 status);
+	    call_destroy_media(call->index);
+	    //call_disconnect(inv, PJSIP_SC_INTERNAL_SERVER_ERROR);
+	    PJSUA_UNLOCK();
+	    return;
+	}
+
+	/* Call's media state is active */
+	call->media_st = PJSUA_CALL_MEDIA_ACTIVE;
+	call->media_dir = sess_info.stream_info[0].dir;
+    }
+
+    /* Print info. */
     {
-	pjmedia_conf_connect_port( pjsua.mconf, 0, call->conf_slot, 0);
-	pjmedia_conf_connect_port( pjsua.mconf, call->conf_slot, 0, 0);
-    }
-
-
-    /* Done. */
-    {
-	struct pjmedia_session_info sess_info;
 	char info[80];
 	int info_len = 0;
 	unsigned i;
 
-	pjmedia_session_get_info(call->session, &sess_info);
 	for (i=0; i<sess_info.stream_cnt; ++i) {
 	    int len;
